
; FASM SOURCE FILE
; http://flatassembler.net

; B2C2

; written by @L.CHEMIST (Andrey A. Meshkov)
; maalchemist@gmail.com
; maa-mail@yandex.ru

; ------------------------------------------------------------------------------

struc GUID def
{
  match d1-d2-d3-d4-d5, def
  \{
   .Data1 dd 0x\#d1
   .Data2 dw 0x\#d2
   .Data3 dw 0x\#d3
   .Data4 db 0x\#d4 shr 8, 0x\#d4 and 0FFh
   .Data5 db 0x\#d5 shr 40, 0x\#d5 shr 32 and 0FFh, 0x\#d5 shr 24 and 0FFh, 0x\#d5 shr 16 and 0FFh, 0x\#d5 shr 8 and 0FFh, 0x\#d5 and 0FFh
  \}
}

; ------------------------------------------------------------------------------

SC_IID_IBaseFilter             EQU 56A86895-0AD4-11CE-B03A-0020AF0BA770

; ------------------------------------------------------------------------------

; B2C2 MPEG2 Filter GUID
SC_CLSID_B2C2MPEG2Filter       EQU E82536A0-94DA-11d2-A463-00A0C95D308D

; B2C2 MPEG2 Filter Tuner Ctrl. Interface GUID
SC_IID_IB2C2MPEG2TunerCtrl     EQU D875D4A9-0749-4fe8-ADB9-CC13F9B3DD45
SC_IID_IB2C2MPEG2TunerCtrl2    EQU CD900832-50DF-4f8f-882D-1C358F90B3F2
SC_IID_IB2C2MPEG2TunerCtrl3    EQU 4B39EB78-D3CD-4223-B682-46AE66968118
SC_IID_IB2C2MPEG2TunerCtrl4    EQU 61A9051F-04C4-435e-8742-9EDD2C543CE9

; B2C2 MPEG2 Filter Tuner Data Ctrl. Interface GUID
SC_IID_IB2C2MPEG2DataCtrl      EQU 7F35C560-08B9-11d5-A469-00D0D7B2C2D7
SC_IID_IB2C2MPEG2DataCtrl2     EQU B0666B7C-8C7D-4c20-BB9B-4A7FE0F313A8
SC_IID_IB2C2MPEG2DataCtrl3     EQU E2857B5B-84E7-48b7-B842-4EF5E175F315
SC_IID_IB2C2MPEG2DataCtrl4     EQU 5927DB1C-B2AC-441f-89A7-C61194D15392
SC_IID_IB2C2MPEG2DataCtrl5     EQU B5AFA7F3-2FBC-4d66-AD9C-FF8616141C26
SC_IID_IB2C2MPEG2DataCtrl6     EQU A12A4531-72D2-40fc-B17D-8F9B0004444F

; B2C2 MPEG2 Filter Audio/Video Ctrl. Interface GUID
SC_IID_IB2C2MPEG2AVCtrl        EQU 295950B0-696D-4a04-9EE3-C031A0BFBEDE
SC_IID_IB2C2MPEG2AVCtrl2       EQU 9C0563CE-2EF7-4568-A297-88C7BB824075
SC_IID_IB2C2MPEG2AVCtrl3       EQU 3CA933BB-4378-4e03-8ABD-02450169AA5E

; B2C2 MPEG2 Timeshift Control Interface GUID
SC_IID_IB2C2MPEG2TimeshiftCtrl EQU A306AF1C-51D9-496d-9E7A-1CFE28F51FDA

; B2C2 MPEG2 Multicast Control Interface GUID
SC_IID_IB2C2MPEG2MulticastCtrl EQU 0B5A8A87-7133-4a37-846E-77F568A52155

; ------------------------------------------------------------------------------

interface I_BaseFilter,\
          QueryInterface,\
          AddRef,\
          Release

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2TunerCtrl,\
          QueryInterface,\
          AddRef,\
          Release,\
          SetFrequency,\
          SetSymbolRate,\
          SetLnbFrequency,\
          SetFec,\
          SetPolarity,\
          SetLnbKHz,\
          SetDiseqc,\
          SetModulation,\
          Initialize,\
          SetTunerStatus,\
          CheckLock,\
          GetTunerCapabilities,\
          GetFrequency,\
          GetSymbolRate,\
          GetModulation,\
          GetSignalStrength,\
          GetSignalLevel,\
          GetSNR,\
          GetPreErrorCorrectionBER,\
          GetUncorrectedBlocks,\
          GetTotalBlocks,\
          GetChannel,\
          SetChannel

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2TunerCtrl2,\
          QueryInterface,\
          AddRef,\
          Release,\
          SetFrequency,\
          SetSymbolRate,\
          SetLnbFrequency,\
          SetFec,\
          SetPolarity,\
          SetLnbKHz,\
          SetDiseqc,\
          SetModulation,\
          Initialize,\
          SetTunerStatus,\
          CheckLock,\
          GetTunerCapabilities,\
          GetFrequency,\
          GetSymbolRate,\
          GetModulation,\
          GetSignalStrength,\
          GetSignalLevel,\
          GetSNR,\
          GetPreErrorCorrectionBER,\
          GetUncorrectedBlocks,\
          GetTotalBlocks,\
          GetChannel,\
          SetChannel,\
          SetTunerStatusEx,\
          SetFrequencyKHz,\
          SetGuardInterval,\
          GetGuardInterval,\
          GetFec,\
          GetPolarity,\
          GetDiseqc,\
          GetLnbKHz,\
          GetLnbFrequency,\
          GetCorrectedBlocks,\
          GetSignalQuality

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2TunerCtrl3,\
          QueryInterface,\
          AddRef,\
          Release,\
          SetFrequency,\
          SetSymbolRate,\
          SetLnbFrequency,\
          SetFec,\
          SetPolarity,\
          SetLnbKHz,\
          SetDiseqc,\
          SetModulation,\
          Initialize,\
          SetTunerStatus,\
          CheckLock,\
          GetTunerCapabilities,\
          GetFrequency,\
          GetSymbolRate,\
          GetModulation,\
          GetSignalStrength,\
          GetSignalLevel,\
          GetSNR,\
          GetPreErrorCorrectionBER,\
          GetUncorrectedBlocks,\
          GetTotalBlocks,\
          GetChannel,\
          SetChannel,\
          SetTunerStatusEx,\
          SetFrequencyKHz,\
          SetGuardInterval,\
          GetGuardInterval,\
          GetFec,\
          GetPolarity,\
          GetDiseqc,\
          GetLnbKHz,\
          GetLnbFrequency,\
          GetCorrectedBlocks,\
          GetSignalQuality,\
          SetBandwidth,\
          GetBandwidth

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2TunerCtrl4,\
          QueryInterface,\
          AddRef,\
          Release,\
          SetFrequency,\
          SetSymbolRate,\
          SetLnbFrequency,\
          SetFec,\
          SetPolarity,\
          SetLnbKHz,\
          SetDiseqc,\
          SetModulation,\
          Initialize,\
          SetTunerStatus,\
          CheckLock,\
          GetTunerCapabilities,\
          GetFrequency,\
          GetSymbolRate,\
          GetModulation,\
          GetSignalStrength,\
          GetSignalLevel,\
          GetSNR,\
          GetPreErrorCorrectionBER,\
          GetUncorrectedBlocks,\
          GetTotalBlocks,\
          GetChannel,\
          SetChannel,\
          SetTunerStatusEx,\
          SetFrequencyKHz,\
          SetGuardInterval,\
          GetGuardInterval,\
          GetFec,\
          GetPolarity,\
          GetDiseqc,\
          GetLnbKHz,\
          GetLnbFrequency,\
          GetCorrectedBlocks,\
          GetSignalQuality,\
          SetBandwidth,\
          GetBandwidth,\
          SendDiSEqCCommand

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2DataCtrl,\
          QueryInterface,\
          AddRef,\
          Release,\
          GetMaxPIDCount,\
          AddPIDs,\
          DeletePIDs,\
          GetMaxIpPIDCount,\
          AddIpPIDs,\
          DeleteIpPIDs,\
          GetIpPIDs,\
          PurgeGlobalPIDs,\
          GetMaxGlobalPIDCount,\
          GetGlobalPIDs,\
          ResetDataReceptionStats,\
          GetDataReceptionStats
  
; ------------------------------------------------------------------------------

interface I_B2C2MPEG2DataCtrl2,\
          QueryInterface,\
          AddRef,\
          Release,\
          GetMaxPIDCount,\
          AddPIDs,\
          DeletePIDs,\
          GetMaxIpPIDCount,\
          AddIpPIDs,\
          DeleteIpPIDs,\
          GetIpPIDs,\
          PurgeGlobalPIDs,\
          GetMaxGlobalPIDCount,\
          GetGlobalPIDs,\
          ResetDataReceptionStats,\
          GetDataReceptionStats,\
          AddPIDsToPin,\
          DeletePIDsFromPin

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2DataCtrl3,\
          QueryInterface,\
          AddRef,\
          Release,\
          GetMaxPIDCount,\
          AddPIDs,\
          DeletePIDs,\
          GetMaxIpPIDCount,\
          AddIpPIDs,\
          DeleteIpPIDs,\
          GetIpPIDs,\
          PurgeGlobalPIDs,\
          GetMaxGlobalPIDCount,\
          GetGlobalPIDs,\
          ResetDataReceptionStats,\
          GetDataReceptionStats,\
          AddPIDsToPin,\
          DeletePIDsFromPin,\
          AddTsPIDs,\
          DeleteTsPIDs,\
          GetTsState,\
          GetIpState,\
          GetReceivedDataIp,\
          AddMulticastMacAddress,\
          GetMulticastMacAddressList,\
          DeleteMulticastMacAddress,\
          SetUnicastMacAddress,\
          GetUnicastMacAddress,\
          RestoreUnicastMacAddress

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2DataCtrl4,\
          QueryInterface,\
          AddRef,\
          Release,\
          GetMaxPIDCount,\
          AddPIDs,\
          DeletePIDs,\
          GetMaxIpPIDCount,\
          AddIpPIDs,\
          DeleteIpPIDs,\
          GetIpPIDs,\
          PurgeGlobalPIDs,\
          GetMaxGlobalPIDCount,\
          GetGlobalPIDs,\
          ResetDataReceptionStats,\
          GetDataReceptionStats,\
          AddPIDsToPin,\
          DeletePIDsFromPin,\
          AddTsPIDs,\
          DeleteTsPIDs,\
          GetTsState,\
          GetIpState,\
          GetReceivedDataIp,\
          AddMulticastMacAddress,\
          GetMulticastMacAddressList,\
          DeleteMulticastMacAddress,\
          SetUnicastMacAddress,\
          GetUnicastMacAddress,\
          RestoreUnicastMacAddress,\
          GetHardwareMacAddress,\
          SetTableId,\
          GetTableId,\
          GetKeyCount,\
          GetKeysInUse,\
          AddKey,\
          DeleteKey,\
          PurgeKeys

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2DataCtrl5,\
          QueryInterface,\
          AddRef,\
          Release,\
          GetMaxPIDCount,\
          AddPIDs,\
          DeletePIDs,\
          GetMaxIpPIDCount,\
          AddIpPIDs,\
          DeleteIpPIDs,\
          GetIpPIDs,\
          PurgeGlobalPIDs,\
          GetMaxGlobalPIDCount,\
          GetGlobalPIDs,\
          ResetDataReceptionStats,\
          GetDataReceptionStats,\
          AddPIDsToPin,\
          DeletePIDsFromPin,\
          AddTsPIDs,\
          DeleteTsPIDs,\
          GetTsState,\
          GetIpState,\
          GetReceivedDataIp,\
          AddMulticastMacAddress,\
          GetMulticastMacAddressList,\
          DeleteMulticastMacAddress,\
          SetUnicastMacAddress,\
          GetUnicastMacAddress,\
          RestoreUnicastMacAddress,\
          GetHardwareMacAddress,\
          SetTableId,\
          GetTableId,\
          GetKeyCount,\
          GetKeysInUse,\
          AddKey,\
          DeleteKey,\
          PurgeKeys,\
          SetCallbackForTransportStream

; ------------------------------------------------------------------------------

interface I_B2C2MPEG2DataCtrl6,\
          QueryInterface,\
          AddRef,\
          Release,\
          GetMaxPIDCount,\
          AddPIDs,\
          DeletePIDs,\
          GetMaxIpPIDCount,\
          AddIpPIDs,\
          DeleteIpPIDs,\
          GetIpPIDs,\
          PurgeGlobalPIDs,\
          GetMaxGlobalPIDCount,\
          GetGlobalPIDs,\
          ResetDataReceptionStats,\
          GetDataReceptionStats,\
          AddPIDsToPin,\
          DeletePIDsFromPin,\
          AddTsPIDs,\
          DeleteTsPIDs,\
          GetTsState,\
          GetIpState,\
          GetReceivedDataIp,\
          AddMulticastMacAddress,\
          GetMulticastMacAddressList,\
          DeleteMulticastMacAddress,\
          SetUnicastMacAddress,\
          GetUnicastMacAddress,\
          RestoreUnicastMacAddress,\
          GetHardwareMacAddress,\
          SetTableId,\
          GetTableId,\
          GetKeyCount,\
          GetKeysInUse,\
          AddKey,\
          DeleteKey,\
          PurgeKeys,\
          SetCallbackForTransportStream,\
          GetDeviceList,\
          SelectDevice

; ------------------------------------------------------------------------------
